#ifdef EZDEBUGMODE
#include <conio.h>
#endif

#define A 0xCF8
#define D 0xCFC
#define BAR2 0x18
#define VENDEV 0x0E63494FL

void outpd( unsigned port, unsigned long value )
{
#ifdef EZDEBUGMODE
    cprintf("writing %08lX to 32-bit Register at %04X\r\n", value, port);
#endif
    _DX = port;
    _EAX = value;
    __emit__( 0x66, 0xEF ); // OUT DX,EAX
}   // outpd

unsigned long inpd( unsigned port )
{   unsigned long data;
    _DX = port;
    __emit__( 0x66, 0xED ); // IN EAX,DX
    data = _EAX;
#ifdef EZDEBUGMODE
    cprintf("read 32-bit Register at %04X, got %08lX\r\n", port, data);
#endif
    return ( data );
}   // inpd

unsigned long readPCIConfigRegister(unsigned long bdf) // takes a bus-device-function value
{ unsigned long data;
  outpd(A, bdf | 0x80000000L);
  data = inpd(D);
#ifdef EZDEBUGMODE
        cprintf("read PCI Config Register at %08lX, got %08lX\r\n", bdf, data);
#endif
  return data;
}

unsigned far pascal _export accesio_GetPCIeAddress(void)
{
    unsigned long busdevfunc = 0;
    unsigned long potentialVENDEV;
    unsigned address;
    do{
        potentialVENDEV = readPCIConfigRegister(busdevfunc);
#ifdef EZDEBUGMODE
        cprintf("PCI BUS reports VENDEV %08lX found \r\n", potentialVENDEV);
#endif
        if (potentialVENDEV == VENDEV) // if our VENDEV
        {
            address = readPCIConfigRegister(busdevfunc + BAR2) & 0x0000FFFCL; // then return BAR0 value, masked to avoid I/O bit confusion
#ifdef EZDEBUGMODE
        cprintf("%08lX device's BAR2 address was read as %04X\n\r", potentialVENDEV, address);
#endif
            return address;
        }
        busdevfunc += (1<<11); // otherwise, check the next possible device/bus/function
    }while (busdevfunc < (255L << 16L) ); // increment "device number", which will wrap to increment bus number as needed // OUR devices only have one function, so we don't have to increment function number, we just leave it "0"
    return -1;
}

void main(void)
{
    unsigned cardaddress;
#ifdef EZDEBUGMODE
        cprintf("START: PCIe-EZ-BLEND address detection test library 1.0\r\n");
#endif
    cardaddress = accesio_GetPCIeAddress();
#ifdef EZDEBUGMODE
    cprintf("DONE: Address was %04X\r\nPress any key to close program.\r\n", cardaddress);
    getch();
#endif

}
